var Emitter = require("events").EventEmitter;
var five = require("../lib/johnny-five.js");
var board = new five.Board();
var emitter = new Emitter();


function Encoder(opts) {
  Emitter.call(this);

  var last = 0;
  var lValue = 0;
  var value = 0;

  var a = new five.Digital(opts.a);
  var b = new five.Digital(opts.b);

  var handler = function() {
    this.emit("data", this.value);

    var MSB = a.value;
    var LSB = b.value;
    var pos, turn;

    if (LSB === 1) {
      pos = MSB === 1 ? 0 : 1;
    } else {
      pos = MSB === 0 ? 2 : 3;
    }

    turn = pos - last;

    if (Math.abs(turn) !== 2) {
      if (turn === -1 || turn === 3){
        value++;
      } else if (turn === 1 || turn === -3) {
        value--;
      }
    }

    last = pos;

    if (lValue !== value) {
      lValue = value;
      this.emit("change", value);
    }
  }.bind(this);

  a.on("data", handler);
  b.on("data", handler);

  Object.defineProperties(this, {
    value: {
      get: function() {
        return value;
      }
    }
  });
}

Encoder.prototype = Object.create(Emitter.prototype, {
  constructor: {
    value: Encoder
  }
});

board.on("ready", function() {
  var encoder = new Encoder({
    a: 2,
    b: 3
  });

  encoder.on("change", function() {
    var aVal = Math.abs(this.value);
    var rotation = aVal % 80 === 0;

    console.log( "Encoder At: %d", this.value );

    if (rotation) {
      console.log( "Rotations: %d", aVal / 80 );
    }
  });
});
